#!/usr/bin/python
##### Aragova tocka - S53MV 17.03.2018 #####

import math,cmath	#uporabljene funkcije

ka=0.005	#korak polmera [m]
amax=1		#polmer odprtine [m]
ll=0.03		#valovna dolzina [m]
d=2.95		#razdalja do ravnine sprejemnika [m]
dd=3.26		#razdalja do ravnine drugega sprejemnika [m]
kz=0.01		#korak po zaslonu [m]
zmin=-3		#zacetek ravnine sprejemnika [m]
zmax=3		#konec ravnine sprejemnika [m]

kf=math.pi/int(3/ka/amax)	#korak kota
k=2*math.pi/ll	#valovno stevilo [rd/m]

x=[]		#polja za risanje grafa
y=[]
z=[]
w=[]
v=[]

zz=zmin
while zz<=zmax:			#zanka cez zaslon
	s=0
	ss=0
	a=ka/2
	while a<amax:		#zanka po polmeru odprtine
		f=kf/2
		while f<2*math.pi:	#zanka po azimutu odprtine
			xo=a*math.cos(f)
			yo=a*math.sin(f)
			r=math.sqrt((xo-zz)*(xo-zz)+yo*yo+d*d)
			rr=math.sqrt((xo-zz)*(xo-zz)+yo*yo+dd*dd)
			s=s+cmath.exp(complex(0,-k*r))*a*(1+d/r)/r
			ss=ss+cmath.exp(complex(0,-k*rr))*a*(1+dd/rr)/rr
			f=f+kf
		a=a+ka
	s=s*complex(0,1)*k*cmath.exp(complex(0,k*d))*ka*kf/(2*math.pi*2)
	ss=ss*complex(0,1)*k*cmath.exp(complex(0,k*dd))*ka*kf/(2*math.pi*2)
	y=y+[abs(s)]	#krozna odprtina
	z=z+[abs(1-s)]	#krozna ovira
	w=w+[abs(ss)]	#krozna odprtina drugi sprejemnik
	v=v+[abs(1-ss)]	#krozna ovira drugi sprejemnik
	x=x+[zz]
	print zz
	zz=zz+kz

import matplotlib.pyplot as plt		#risanje grafa funkcije
fig=plt.figure(figsize=(4,8))
plt.plot(w,x,'g-')
plt.plot(y,x,'m-')
plt.axis([0,2,zmin,zmax])
plt.xticks([0,0.5,1,1.5,2],['0',r'$E_\infty$/2',r'$E_\infty$',r'3$E_\infty$/2',r'2$E_\infty$'])
plt.title('Okrogla odprtina $a$=1m')
plt.xlabel('Amplituda uklonjenega polja |$E$|')
plt.grid(True)
fig.savefig('arago1.svg', transparent=True)
fig=plt.figure(figsize=(4,8))
#plt.plot(v,x,'g-')
plt.plot(z,x,'m-')
plt.axis([0,2,zmin,zmax])
plt.xticks([0,0.5,1,1.5,2],['0',r'$E_\infty$/2',r'$E_\infty$',r'3$E_\infty$/2',r'2$E_\infty$'])
plt.title('Okrogla ovira $a$=1m')
plt.xlabel('Amplituda uklonjenega polja |$E$|')
plt.grid(True)
fig.savefig('arago2.svg', transparent=True)
plt.show()

#konec programa

